if (typeof (Avanade) == "undefined") { Avanade = { __namespace: true }; }
if (typeof (Avanade.Hlv) == "undefined") { Avanade.Hlv = { __namespace: true }; }
if (typeof (Avanade.Hlv.PortalFornitori) == "undefined") { Avanade.Hlv.PortalFornitori = { __namespace: true }; }

$(document).ready(function () {

    (function (webapi, $) {
        function safeAjax(ajaxOptions) {
            var deferredAjax = $.Deferred();

            shell.getTokenDeferred().done(function (token) {
                // add headers for AJAX
                if (!ajaxOptions.headers) {
                    $.extend(ajaxOptions, {
                        headers: {
                            "__RequestVerificationToken": token
                        }
                    });
                } else {
                    ajaxOptions.headers["__RequestVerificationToken"] = token;
                }
                $.ajax(ajaxOptions)
                    .done(function (data, textStatus, jqXHR) {
                        validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
                    }).fail(deferredAjax.reject); //AJAX
            }).fail(function () {
                deferredAjax.rejectWith(this, arguments); // on token failure pass the token AJAX and args
            });

            return deferredAjax.promise();
        }
        webapi.safeAjax = safeAjax;
    })(window.webapi = window.webapi || {}, jQuery)

    if (!Avanade.Hlv.PortalFornitori.Common.isStringNullOrEmpty(window.location.pathname)) {
        if (window.location.pathname.replace("/", "").trim().toLocaleLowerCase().indexOf("signin") > -1) {
            var form =
                '<form id="form-signin-custom">' +
                '<div class="form-horizontal">' +
                '<div class="form-group">' +
                '<label class="col-sm-4 control-label required" for="UsernameCustom"><span class="xrm-editable-text xrm-attribute"><span class="xrm-attribute-value-encoded xrm-attribute-value">Nome utente</span></span></label>' +
                '<div class="col-sm-8">' +
                '<input class="form-control" id="UsernameCustom" name="UsernameCustom" type="text" value="" aria-required="true">' +
                '<a id="signin-custom" href="#">Accedi</a>' +
                '</div>' +
                '</div>' +
                '</div>' +
                '</form>';

            //$('form[action="/SignIn?ReturnUrl=%2F"]').parent().append('<a id="signin-custom" class="signin-custom" href="#">Accedi</a>');
            $('form[action^="/Account/Login/ExternalLogin"]').parent().append(form);
            $('form[action^="/Account/Login/ExternalLogin"] button').hide();

            if (window.location.hostname.indexOf("sandbox") == -1) {
                $('form[action^="/SignIn?ReturnUrl=%2F"]').parent().hide()
                $('form[action^="/SignIn?ReturnUrl=%2F"] div div.form-group').hide();
                $('form[action="/SignIn?ReturnUrl=%2F"] div #loginValidationSummary + div').hide()
            }
        }

        if (window.location.pathname.replace("/", "").trim().toLocaleLowerCase().indexOf("signin") == -1) {
            if (!Avanade.Hlv.PortalFornitori.Common.isStringNullOrEmpty(window.location.search)) {
                if (window.location.search.indexOf("login_completed") > -1) {
                    window.location.search = window.location.search.replace("login_completed=true", "");
                }
            }
        }
    }

    if (!Avanade.Hlv.PortalFornitori.Common.isStringNullOrEmpty(window.location.search)) {
        if (window.location.search.indexOf("login_completed") > -1) {
            var loaderdiv = '<div class="col-md-12" id="articoli-loader"><div class="custom-loader"></div></div>'
            $('form[action^="/SignIn?ReturnUrl=%2F"]').parent().hide();
            $('form[action^="/Account/Login/ExternalLogin"]').parent().hide();

            $('form[action^="/Account/Login/ExternalLogin"]').parent().parent().append(loaderdiv);

            $('form[action^="/Account/Login/ExternalLogin"] button').click();
        }
    }

    $("#form-signin-custom").on("submit", function () {
        return false;
    })

    $("#signin-custom").on("click", function () {
        var dominio = "@helvetia.onmicrosoft.com";
        var domain_hint = "helvetia.onmicrosoft.com";

        var user = $("#UsernameCustom").val();
        var host = window.location.hostname.replace(":", "%3A").replace("/", "%2F");
        var tenantId = $('form[action="/Account/Login/ExternalLogin?ReturnUrl=%2F"] div button').attr("value");
        var tenantId = "e6fb9963-6256-4aa8-8dbd-e45305f4dd5e";
        var clientIdSvil = "363828f1-a1a7-443a-bf41-f79d4599d261";
        var clientIdColl = "2c1645c1-dfba-427a-9e73-4c0abfff523c";
        var clientIdProd = "47871d3a-d928-4159-aebd-c247106d7c0a";
        var clientId = "";

        if (window.location.hostname.indexOf("sandbox") > -1) {
            clientId = clientIdSvil;
        }
        else if (window.location.hostname.indexOf("collaudo") > -1) {
            clientId = clientIdColl;
        }
        else {
            clientId = clientIdProd;
        }

        var url = "https://login.microsoftonline.com/";

        url += tenantId + "/oauth2/authorize?response_type=code";
        url += "&scope=openid%20profile";
        url += "&client_id=" + clientId;
        url += "&redirect_uri=https%3A%2F%2F" + host + "?login_completed=true";
        url += "&response_mode=form_post";
        url += "&sso_reload=true";
        url += "&login_hint=" + user + dominio;
        url += "&domain_hint=" + domain_hint;

        // $("#signin-custom").attr("href", url);
        // $("#signin-custom")[0].click();
        window.location.href = url;
    })
})

Avanade.Hlv.Rest = new function () {
    const self = this;
    var getXhr = function () {
        ///<summary>
        /// Get an instance of XMLHttpRequest for all browsers
        ///</summary>
        if (window.XMLHttpRequest) {
            // Chrome, Firefox, IE7+, Opera, Safari
            // ReSharper disable InconsistentNaming
            return new window.XMLHttpRequest();
            // ReSharper restore InconsistentNaming
        }
        // IE6
        try {
            // The latest stable version. It has the best security, performance,
            // reliability, and W3C conformance. Ships with Vista, and available
            // with other OS's via downloads and updates.
            return new window.ActiveXObject("MSXML2.XMLHTTP.6.0");
        } catch (e) {
            try {
                // The fallback.
                return new window.ActiveXObject("MSXML2.XMLHTTP.3.0");
            } catch (e) {
                window.alertMessage("This browser is not AJAX enabled.");
                return null;
            }
        }
    };

    var dateReviver = function (key, value) {
        var a;
        if (typeof value === "string") {
            a = /Date\(([-+]?\d+)\)/.exec(value);
            if (a) {
                return new Date(parseInt(value.replace("/Date(", "").replace(")/", ""), 10));
            }
        }
        return value;
    };

    var errorHandler = function (req) {
        return new Error("Error : " + req.status + ": " + req.statusText + ": " + JSON.parse(req.responseText).error.message.value);
    };

    var stringParameterCheck = function (parameter, message) {
        if (typeof parameter != "string") {
            throw new Error(message);
        }
    };

    var callbackParameterCheck = function (callbackParameter, message) {
        if (typeof callbackParameter != "function") {
            throw new Error(message);
        }
    };

    var booleanParameterCheck = function (parameter, message) {
        if (typeof parameter != "boolean") {
            throw new Error(message);
        }
    };

    self.Get = function (url, successCallback, errorCallback, async) {
        stringParameterCheck(url, "Avanade.Hlv.Rest.Get requires the url parameter is a string.");
        callbackParameterCheck(successCallback, "Avanade.Hlv.Rest.Get requires the successCallback parameter is a function.");
        callbackParameterCheck(errorCallback, "Avanade.Hlv.Rest.Get requires the errorCallback parameter is a function.");
        booleanParameterCheck(async, "Avanade.Hlv.Rest.Get requires the async parameter is a boolean.");

        var req = getXhr();
        req.open("GET", url, async);
        req.setRequestHeader("Accept", "application/json");
        req.setRequestHeader("Content-Type", "application/json; charset=utf-8");

        if (async) {
            req.onreadystatechange = function () {
                if (req.readyState === 4 /* complete */) {
                    if (req.status === 200) {
                        return successCallback(JSON.parse(req.responseText, dateReviver));
                    } else {
                        return errorCallback(errorHandler(req));
                    }
                }
            };
            req.send();
        } else {
            req.send();
            if (req.status === 200) {
                return JSON.parse(req.responseText, dateReviver);
            } else {
                return errorCallback(errorHandler(req));
            }
        }
    };
};

Avanade.Hlv.PortalFornitori.Common = new function () {
    const self = this;

    self.isStringNullOrEmpty = function (string) {

        if (string == null)
            return true;

        if (typeof string === "undefined")
            return true;

        if (string.trim() == "")
            return true;

        return false;
    };
};

Avanade.Hlv.PortalFornitori.HelpDesk = new function () {
    const self = this;
    var userId;
    var mustApplyFilter = false;

    self.init = function () {
        var isloaded = false;

        userId = $("#currentuserid").val();

        $(".entity-grid.entitylist").on("loaded", function () {

            $(".entitylist .grid-actions .dropdown-menu a[aria-posinset='1']").attr("onclick", "Avanade.Hlv.PortalFornitori.HelpDesk.setFilter(1)")
            $(".entitylist .grid-actions .dropdown-menu a[aria-posinset='2']").attr("onclick", "Avanade.Hlv.PortalFornitori.HelpDesk.setFilter(2)")
            $(".entitylist .grid-actions .dropdown-menu a[aria-posinset='3']").attr("onclick", "Avanade.Hlv.PortalFornitori.HelpDesk.setFilter(3)")
            $(".entitylist .grid-actions .dropdown-menu a[aria-posinset='4']").attr("onclick", "Avanade.Hlv.PortalFornitori.HelpDesk.setFilter(4)")

            if ($('.input-group.entitylist-filter-option-text input[name="0"]').val() != "" || $('.input-group.entitylist-filter-option-text input[name="1"]').val() != "") {
                if (mustApplyFilter) {
                    $(".btn.btn-default.btn-entitylist-filter-submit").click();
                    mustApplyFilter = false;
                }
            }
        });


        $(".entitylist").on("loaded", function () {

            if ($(".entitylist tr td:last-child div ul li a.prendi-in-carico-link").length == 0) {
                $(".entitylist tr td:last-child div ul")
                    .prepend('<li role="none">' +
                        '<a class="prendi-in-carico-link" role="menuitem" tabindex="-1" href="#" title="Prendi in carico" aria-setsize="1" aria-posinset="1">' +
                        '<span class="fa fa-info-circle fa-fw" aria-hidden="true"></span> Prendi in carico' +
                        '</a>' +
                        '</li>')
                isloaded = true;

                $(".entitylist .prendi-in-carico-link").on("click", function () {
                    var currentElem = $(this)
                    $('body').css('cursor', 'wait');
                    var currid = $(currentElem.parent().parent().parent().parent().parent()).data("id");

                    // var dataObject = {
                    //     "hlv_partner@odata.bind": "/contacts(" + $("#header-user-id").val() + ")",
                    //     "hlv_caseid@odata.bind": "/incidents(" + currid + ")",
                    //     "hlv_name": "Aggiornamento fornitore case " + currid
                    // };

                    var dataObject = {
                        "hlv_partner": "contact;" + $("#header-user-id").val(),
                        "hlv_caseid@odata.bind": "/incidents(" + currid + ")",
                        "hlv_name": "Aggiornamento fornitore case " + currid
                    };

                    webapi.safeAjax({
                        type: "POST",
                        url: "/_api/hlv_portalcases",
                        contentType: "application/json",
                        data: JSON.stringify(dataObject),
                        success: function (res, status, xhr) {
                            var id = xhr.getResponseHeader("entityid");
                            var portalHostName = window.location.host;
                            var portalURL = "https://" + portalHostName;
                            //var url = portalURL + "/caseokupdate/?id=" + incidentId;
                            //window.location.href = url;
                            window.location.href = $($(currentElem.parent().parent()).children()[1]).children().attr("href");
                        },
                        error: function (res, exception) {
                            console.log(res);
                            console.log(exception);
                            // $("#modal-nonincident").modal("hide");
                            // location.reload();
                        }
                    });

                    // webapi.safeAjax({
                    //     type: "PATCH",
                    //     url: "/_api/incidents(" + currid + ")",
                    //     contentType: "application/json",
                    //     data: JSON.stringify(dataObject),
                    //     success: function (res, status, xhr) {
                    //         var portalHostName = window.location.host;
                    //         var portalURL = "https://" + portalHostName;
                    //         //var url = portalURL + "/caseokupdate/?id=" + incidentId;
                    //         //window.location.href = url;
                    //         window.location.href = $($(currentElem.parent().parent()).children()[1]).children().attr("href");
                    //     },
                    //     error: function (res, exception) {
                    //         console.log(res);
                    //         console.log(exception);
                    //     }
                    // });
                })
            }
			
			$(".entitylist td[data-attribute=\"description\"]").hide();
			$(".entitylist th").eq($(".entitylist td[data-attribute=\"description\"]").index()).hide();
        })
		
    };

    self.setFilter = function (i) {
        if (i == null)
            return;
        switch (i.toString()) {
            case "1":
                $('.input-group.entitylist-filter-option-text input[name="0"]').val("");
                $('.input-group.entitylist-filter-option-text input[name="1"]').val("");
                break;
            case "2":
                $('.input-group.entitylist-filter-option-text input[name="0"]').val(userId);
                $('.input-group.entitylist-filter-option-text input[name="1"]').val("");

                break;
            case "3":
                $('.input-group.entitylist-filter-option-text input[name="0"]').val("");
                $('.input-group.entitylist-filter-option-text input[name="1"]').val(userId);

                break;
            case "4":
                $('.input-group.entitylist-filter-option-text input[name="0"]').val("");
                $('.input-group.entitylist-filter-option-text input[name="1"]').val("");
                break;

        }
        mustApplyFilter = true;

    };

};

Avanade.Hlv.PortalFornitori.DetailCase = new function () {
    const self = this;

    self.init = function () {
        $($("#EntityFormPanel .form-custom-actions .col-sm-6")[0]).append('<input type="button" id="AssegnaRichiedente" title="Assegna a Richiedente" class="btn btn-primary button submit-btn" style="margin-left:2%" value="Assegna a Richiedente" >');
        $($("#EntityFormPanel .form-custom-actions .col-sm-6")[0]).append('<input type="button" id="AssegnaCustom" title="Assegna" class="btn btn-primary button submit-btn" style="margin-left:2%" value="Assegna" >');
        var channel = $("#hlv_channel").val();
		if(channel == '855600007'){
			$($("#EntityFormPanel .form-custom-actions .col-sm-6")[0]).append('<input type="button" id="Asset" title="Asset" class="btn btn-primary button submit-btn" style="margin-left:2%" value="Asset" >');

		}
		else{
			$($("#EntityFormPanel .form-custom-actions .col-sm-6")[0]).append('<input type="button" id="InfoAgenzia" title="Info Agenzia" class="btn btn-primary button submit-btn" style="margin-left:2%" value="Info Agenzia" >');	
		}
		
        if (channel == null || channel.trim() == "") {
	            $("#hlv_nonincident_label").parent().parent().hide();
				$("#hlv_outofcompetence_label").parent().parent().hide();
		}


        $("#AssegnaCustom").on("click", function () {
            var teamList = [];

            //recuperare team ultima movimentazione chiusa
            var teamLastMov = $("#caseteamowner-input").val();
            var teamNameLastMov = $("#caseteamownerName-input").val();

            if (teamLastMov != null && teamLastMov != "" && teamNameLastMov != null && teamNameLastMov != "") {
                teamList.push({ teamId: teamLastMov, teamName: teamNameLastMov });
            }

            //recuperare team di assegnazione dal case team owner
            if ($("#assNewTeams-size").val() > 0) {
                for (var i = 0; i < $("#assNewTeams-size").val(); i++) {
                    var teamName = $("#assNewTeams-name-" + i).val();
                    var teamId = $("#assNewTeams-teamid-" + i).val();

                    if (teamId != null && teamId != "" && teamName != null && teamName != "") {
                        var isPresent = teamList.find(function (t) { return t.teamId == teamId });
                        if (isPresent == null) {
                            teamList.push({ teamId: teamId, teamName: teamName });
                        }
                    }
                }
            }

            //popolare la select
            $("#select-team").html("");
            $("#select-team").append('<option value="0">-</option>');

            for (var i = 0; i < teamList.length; i++) {
                if (teamList[i].teamId != null) {
                    $("#select-team").append('<option value="' + teamList[i].teamId + '">' + teamList[i].teamName + '</option>');
                }

            }

            $("#modal-assign").modal("show");
        });

        $("#AssegnaRichiedente").on("click", function () {
            var fase3Channels = ["855600004", "855600005", "855600007"];
            var fase2Channels = ["855600002"];
            var channel = $("#hlv_channel").val();
            var incidentId = $("#current-incident-id").val();

            debugger;

            var statusCode = fase3Channels.includes(channel) ? "855600004" : fase2Channels.includes(channel) ? "3" : -1;

            if (statusCode == -1) {
                return;
            }

            // var dataObject = {
            //     'hlv_statecode': 0,
            //     'hlv_statuscode': statusCode,
            //     'hlv_isassigned': true,
            //     'hlv_partner': null,
            //     "hlv_caseid@odata.bind": "/incidents(" + incidentId + ")",
            //     "hlv_name": "Aggiornamento fornitore case " + incidentId
            // };

            var dataObject = {
                'hlv_statecode': "0",
                'hlv_statuscode': statusCode,
                'hlv_isassigned': "true",
                'hlv_partner': "null",
                "hlv_caseid@odata.bind": "/incidents(" + incidentId + ")",
                "hlv_name": "Aggiornamento fornitore case " + incidentId
            };

            $('body').css('cursor', 'wait');

            webapi.safeAjax({
                type: "POST",
                url: "/_api/hlv_portalcases",
                contentType: "application/json",
                data: JSON.stringify(dataObject),
                success: function (res, status, xhr) {
                    var portalHostName = window.location.host;
                    var portalURL = "https://" + portalHostName;
                    var url = portalURL + "/caseokupdate/?id=" + incidentId;
                    //window.location.href = url;
                    //location.reload();
                    window.location.href = "/support";
                },
                error: function (res, exception) {
                    console.log(res);
                    console.log(exception);
                }
            });

            // webapi.safeAjax({
            //     type: "PATCH",
            //     url: "/_api/incidents(" + incidentId + ")",
            //     contentType: "application/json",
            //     data: JSON.stringify(dataObject),
            //     success: function (res, status, xhr) {
            //         var portalHostName = window.location.host;
            //         var portalURL = "https://" + portalHostName;
            //         var url = portalURL + "/caseokupdate/?id=" + incidentId;
            //         //window.location.href = url;
            //         //location.reload();
            //         window.location.href = "/support";
            //     },
            //     error: function (res, exception) {
            //         console.log(res);
            //         console.log(exception);
            //     }
            // });
        });

        $("#InfoAgenzia").on("click", function () {
            $("#modal-asset").modal('show');
        });
		
		$("#Asset").on("click", function () {
            $("#modal-asset-direzione").modal('show');
        });

        if ($("#hlv_outofcompetence") != null && $("#hlv_outofcompetence").length > 0) {
            $("#hlv_outofcompetence").attr("onclick", $("#hlv_outofcompetence").attr("onclick") + ";Avanade.Hlv.PortalFornitori.DetailCase.showModalNonIncident('2')")
        };
        if ($("#hlv_nonincident") != null && $("#hlv_nonincident").length > 0) {
            $("#hlv_nonincident").attr("onclick", $("#hlv_nonincident").attr("onclick") + ";Avanade.Hlv.PortalFornitori.DetailCase.showModalNonIncident('1')")
        };

        if ($("#caseorigincode-val-input").val() != "855600002") {
            $('[data-name="tab_8"]').prev().hide();
            $('[data-name="tab_8"]').hide();
        };

        $('[data-name="sla_tab"] label[for="QuickviewControlTakeInCharge"]').text("Data Presa in Carico Massima");
        $('[data-name="sla_tab"] label[for="QuickviewControlResolveBy"]').text("Data Risoluzione Massima")

        if ($("#hlv_partner").val() != null && $("#hlv_partner").val() != "") {
            $('[data-name="sla_tab"] label[for="QuickviewControlTakeInCharge"]').parent().parent().hide()
        };
    };

    self.executeCustomAssign = function () {
        var incidentId = $("#current-incident-id").val();
        var teamSelected = $("#select-team").val();
        if (teamSelected == null || teamSelected == "" || teamSelected == 0)
            return;

        var teamName = $("#select-team option:selected").text();
        if (teamName == null || teamName == "" || teamName == "-")
            return;

        //aggiorna l'owner del ticket
        // var dataObject = {
        //     "hlv_teamownerid@odata.bind": "/teams(" + teamSelected + ")",
        //     "hlv_partner": null,
        //     "hlv_caseid@odata.bind": "/incidents(" + incidentId + ")",
        //     "hlv_name": "Aggiornamento fornitore case " + incidentId
        // };
        var dataObject = {
            "hlv_teamownerid": "team;" + teamSelected,
            "hlv_partner": "null",
            "hlv_caseid@odata.bind": "/incidents(" + incidentId + ")",
            "hlv_name": "Aggiornamento fornitore case " + incidentId
        };

        $('body').css('cursor', 'wait');

        webapi.safeAjax({
            type: "POST",
            url: "/_api/hlv_portalcases",
            contentType: "application/json",
            data: JSON.stringify(dataObject),
            success: function (res, status, xhr) {
                var portalHostName = window.location.host;
                var portalURL = "https://" + portalHostName;
                //var url = portalURL + "/caseokupdate/?id=" + incidentId;
                window.location.href = "/support";
                //location.reload();
                //$("#EntityFormPanel .form-custom-actions .col-sm-6 #UpdateButton").click();
            },
            error: function (res, exception) {
                console.log(res);
                console.log(exception);
            }
        });

        // webapi.safeAjax({
        //     type: "PATCH",
        //     url: "/_api/incidents(" + incidentId + ")",
        //     contentType: "application/json",
        //     data: JSON.stringify(dataObject),
        //     success: function (res, status, xhr) {
        //         var portalHostName = window.location.host;
        //         var portalURL = "https://" + portalHostName;
        //         //var url = portalURL + "/caseokupdate/?id=" + incidentId;
        //         window.location.href = "/support";
        //         //location.reload();
        //         //$("#EntityFormPanel .form-custom-actions .col-sm-6 #UpdateButton").click();
        //     },
        //     error: function (res, exception) {
        //         console.log(res);
        //         console.log(exception);
        //     }
        // });
    };

    self.showModalNonIncident = function (modalType) {

        var teamList = [];

        if ($("#assNewTeams-size").val() > 0) {
            for (var i = 0; i < $("#assNewTeams-size").val(); i++) {
                var teamName = $("#assNewTeams-name-" + i).val();
                var teamId = $("#assNewTeams-teamid-" + i).val();

                if (teamId != null && teamId != "" && teamName != null && teamName != "") {
                    teamList.push({ teamId: teamId, teamName: teamName });
                }
            }
        }

        //popolare la select
        $("#select-team2").html("");
        $("#select-team2").append('<option value="0">-</option>');

        for (var i = 0; i < teamList.length; i++) {
            if (teamList[i].teamId != null) {
                $("#select-team2").append('<option value="' + teamList[i].teamId + '">' + teamList[i].teamName + '</option>');
            }
        }

        if (teamList.length == 1) {
            $("#select-team2").val(teamList[0].teamId);
            $("#select-team2").attr("disabled", "disabled");
        }

        if ($("#hlv_outofcompetence").is(":checked") && modalType == "2") {
            $("#modal-nonincident .modal-title").text("Incident Non Di Competenza");
        }
        else if ($("#hlv_nonincident").is(":checked") && modalType == "1") {
            $("#modal-nonincident .modal-title").text("Incident Non Incident");
        }
        else {
            return;
        }

        $("#modal-nonincident").modal("show");
    };

    self.executeNonIncident = function () {
        var modalType = $("#hlv_nonincident").is(":checked") ? 1 : 2;

        var incidentId = $("#current-incident-id").val();
        var incidentTitle = $("#caseTitle-input").val();
        var caseTeamOwner_id = $("#currTeam-teamid").val();
        var caseTeamOwner_teamtype = $("#currTeam-teamtype").val();
        var caseTeamOwner_referral = $("#currTeam-referralteam").val();

        //var refTeam_id = $("#refTeam-teamid").val();

        var refTeam_id = $("#select-team2").val();

        // if ((refTeam_id == null || refTeam_id == "") && (!caseTeamOwner_referral || caseTeamOwner_referral == "false")) {
        //     return;
        // }

        if (refTeam_id == null || refTeam_id == "") {
            return;
        }

        var succTeam_id = $("#succTeam-teamid").val();

        var subject = modalType == 1 ? incidentTitle + " - Non Incident" : incidentTitle + " - Non Di Competenza";
        var description = $("#modal-nonincident #task-desc").val();
        var channel = $("#hlv_channel").val();
        var incidentType = modalType == 1 ? 855600000 : 855600001;

        //var newOwnerId = caseTeamOwner_referral ? succTeam_id : refTeam_id;
        var newOwnerId = refTeam_id;

        var data = {
            "subject": subject,
            "description": description,
            "hlv_taskorigincode": 855600000,
            "regardingobjectid_incident@odata.bind": "/incidents(" + incidentId + ")",
            "ownerid@odata.bind": "/teams(" + newOwnerId + ")",
            "hlv_requestingteam_Task@odata.bind": "/teams(" + caseTeamOwner_id + ")",
            "hlv_incidenttype": incidentType
        };

        if (channel != null) {
            data["hlv_channel"] = parseInt(channel);
        }

        $('body').css('cursor', 'wait')

        webapi.safeAjax({
            type: "POST",
            url: "/_api/tasks",
            contentType: "application/json",
            data: JSON.stringify(data),
            success: function (res, status, xhr) {
                var id = xhr.getResponseHeader("entityid");

                // var dataObject = {
                //     "hlv_statuscode": 2, //on hold
                //     "hlv_lockdate": new Date(),
                //     "hlv_caseid@odata.bind": "/incidents(" + incidentId + ")",
                //     "hlv_name": "Aggiornamento fornitore case " + incidentId
                // };
                var dataObject = {
                    "hlv_statuscode": "2", //on hold
                    "hlv_lockdate": (new Date()).toISOString(),
                    "hlv_caseid@odata.bind": "/incidents(" + incidentId + ")",
                    "hlv_name": "Aggiornamento fornitore case " + incidentId
                };
                if (modalType == 1){
                    dataObject["hlv_nonincident"] = "true"
                }
                else{
                    dataObject["hlv_outofcompetence"] = "true"
                }

                webapi.safeAjax({
                    type: "POST",
                    url: "/_api/hlv_portalcases",
                    contentType: "application/json",
                    data: JSON.stringify(dataObject),
                    success: function (res, status, xhr) {
                        $("#modal-nonincident").modal("hide");
                        //$("#EntityFormPanel .form-custom-actions .col-sm-6 #UpdateButton").click();
                        window.location.href = "/support";
                    },
                    error: function (res, exception) {
                        console.log(res);
                        console.log(exception);
                    }
                });

                // webapi.safeAjax({
                //     type: "PATCH",
                //     url: "/_api/incidents(" + incidentId + ")",
                //     contentType: "application/json",
                //     data: JSON.stringify(dataObject),
                //     success: function (res, status, xhr) {
                //         $("#modal-nonincident").modal("hide");
                //         $("#EntityFormPanel .form-custom-actions .col-sm-6 #UpdateButton").click();
                //     },
                //     error: function (res, exception) {
                //         console.log(res);
                //         console.log(exception);
                //     }
                // });

            },
            error: function (res, exception) {
                console.log(res);
                console.log(exception);
                // $("#modal-nonincident").modal("hide");
                // location.reload();
            }
        });
    };
};






